--- 12beta1.md.orig	2019-05-22 06:33:16.286099932 +0200
+++ 12beta1.md	2019-05-22 06:48:24.279966057 +0200
@@ -30,12 +30,12 @@
 Additionally, PostgreSQL 12 adds the ability to rebuild indexes concurrently,
 which lets you perform a [`REINDEX`](https://www.postgresql.org/docs/devel/sql-reindex.html) operation
 without blocking any writes to the index. The inclusion of this feature should
-help with length index rebuilds that could cause potential downtime evens when
-administration a PostgreSQL database in a production environment.
+help with lengthy index rebuilds that could cause potential downtime when
+administrating a PostgreSQL database in a production environment.
 
 PostgreSQL 12 extends the abilities of several of the specialized indexing
 mechanisms. The ability to create covering indexes, i.e. the `INCLUDE` clause
-that was introduced in PostgreSQL 11, have now been added to GiST indexes.
+that was introduced in PostgreSQL 11, has now been added to GiST indexes.
 SP-GiST indexes now support the ability to perform K-nearest neighbor (K-NN)
 queries for data types that support the distance (`<->`) operation.
 
@@ -49,7 +49,7 @@
 
 Common table expressions (aka `WITH` queries) can now be automatically inlined
 in a query if they are a) not recursive, b) do not have any side-effects and
-c) are only referenced once in a later part of a query. These removes a known
+c) are only referenced once in a later part of a query. This removes a known
 "optimization fence" that has existed since the introduction of the `WITH`
 clause in PostgreSQL 8.4
 
@@ -88,7 +88,7 @@
 PostgreSQL 12 now supports case-insensitive and accent-insensitive collations
 for ICU provided collations, also known as "[nondeterministic collations](https://www.postgresql.org/docs/devel/collation.html#COLLATION-NONDETERMINISTIC)".
 When used, these collations can provide convenience for comparisons and sorts,
-but can also lead to a performance penalty depending as a collation may need to
+but can also lead to a performance penalty as a collation may need to
 make additional checks on a string.
 
 ### Most-common Value Statistics
@@ -102,10 +102,9 @@
 
 PostgreSQL 12 lets you create [generated columns](https://www.postgresql.org/docs/devel/ddl-generated-columns.html)
 that compute their values based on the contents of other columns. This feature
-provides two types of generated columns:
-
-- Stored generated columns, which are computed on inserts and updated and are saved on disk
-- Virtual generated columns, which are computed only when a column is read as part of a query
+provides only one type of generated column: Stored generated columns, which are computed on inserts
+and updated and are saved on disk. Virtual generated columns (computed only when a column
+is read as part of a query) are not yet implemented.
 
 ### Pluggable Table Storage Interface
 
@@ -128,7 +127,7 @@
 
 ### Authentication
 
-GSSAPI now supports client and server-side encryption and can be specified in
+GSSAPI now supports client- and server-side encryption and can be specified in
 the [`pg_hba.conf`](https://www.postgresql.org/docs/devel/auth-pg-hba-conf.html)
 file using the `hostgssenc` and `hostnogssenc` record types. PostgreSQL 12 also
 allows for LDAP servers to be discovered based on `DNS SRV` records if
